package com.loganmagnan.pluginbase.utils.config.file;

import com.loganmagnan.pluginbase.PluginBase;
import com.loganmagnan.pluginbase.utils.ConfigUpdater;
import lombok.Getter;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;

@Getter
public class Config {

	private final FileConfiguration config;
	private final File configFile;
	protected boolean wasCreated;

	public Config(String name, JavaPlugin plugin, boolean update) {
		this.configFile = new File(plugin.getDataFolder() + "/" + name + ".yml");
		if (!this.configFile.exists()) {
			try {
				this.configFile.getParentFile().mkdirs();
				this.configFile.createNewFile();
				this.wasCreated = true;
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		try {
			if (update) {
				ConfigUpdater.update(PluginBase.getInstance(), name + ".yml", this.configFile);
			}
		} catch (Exception exception) {
			exception.printStackTrace();
		}

		this.config = YamlConfiguration.loadConfiguration(this.configFile);
	}

	public void save() {
		try {
			this.config.save(configFile);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
